// Generated by CoffeeScript 1.4.0
(function() {
  var Asset, EventEmitter, async, fs, mime, pathutil, rack,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  fs = require('fs');

  pathutil = require('path');

  async = require('async');

  rack = require('../index');

  mime = require('mime');

  EventEmitter = require('events').EventEmitter;

  Asset = require('../.').Asset;

  exports.StaticAssets = (function(_super) {

    __extends(StaticAssets, _super);

    function StaticAssets() {
      return StaticAssets.__super__.constructor.apply(this, arguments);
    }

    StaticAssets.prototype.create = function(options) {
      var _this = this;
      this.dirname = pathutil.resolve(options.dirname);
      this.urlPrefix = options.urlPrefix;
      if (this.urlPrefix.substr(-1, 1) !== '/') {
        this.urlPrefix += '/';
      }
      this.assets = [];
      return this.getAssets(this.dirname, this.urlPrefix, function() {
        return _this.emit('created');
      });
    };

    StaticAssets.prototype.getAssets = function(dirname, prefix, next) {
      var filenames,
        _this = this;
      if (prefix == null) {
        prefix = '';
      }
      filenames = fs.readdirSync(dirname);
      return async.forEachSeries(filenames, function(filename, next) {
        var asset, contents, ext, mimetype, newPrefix, path, stats, url;
        if (filename.slice(0, 1) === '.') {
          return next();
        }
        path = pathutil.join(dirname, filename);
        stats = fs.statSync(path);
        if (stats.isDirectory()) {
          newPrefix = "" + prefix + (pathutil.basename(path)) + "/";
          return _this.getAssets(path, newPrefix, function(newAssets) {
            _this.assets.concat(newAssets);
            return next();
          });
        } else {
          url = prefix + filename;
          ext = pathutil.extname(path);
          mimetype = mime.types[ext.slice(1, ext.length)];
          contents = fs.readFileSync(path);
          if (mimetype != null) {
            asset = new Asset({
              url: url,
              contents: contents,
              mimetype: mime.types[ext.slice(1, ext.length)],
              hash: _this.hash,
              maxAge: _this.maxAge
            });
            return asset.on('complete', function() {
              _this.assets.push(asset);
              return next();
            });
          } else {
            return next();
          }
        }
      }, function(error) {
        return next();
      });
    };

    return StaticAssets;

  })(Asset);

}).call(this);
